// test_ispal.cpp
// Glenn G. Chappell
// 3 Dec 2013
//
// For CS 202 Fall 2013
// Test program for function isPal

#include "ispal.h"  // For function isPal
#include "ispal.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;


bool allGood = true;  // true if all tests pass so far


// str
// Return string form of bool: "true" or "false", as appropriate.
string str(bool b)
{
    return b ? "true" : "false";
}


// takesBool
// Function that takes bool by reference -- for return-type checking.
void takesBool(bool & b)
{}


// test_isPal_letters
// Test for isPal: strings consisting of letters, matching case only
// Prints results of tests, sets global allGood to false if any fail
void test_isPal_letters()
{
    cout << endl;
    cout << "Test suite: strings consisting of letters, matching case only"
         << endl;

    // Return-type check (passes if it compiles)
    {
    auto result = isPal("abc");
    takesBool(result);  // Should only compile if binSearch returns bool
    }

    // Empty string
    {
    string s = "";
    auto result = isPal(s);
    cout << "Empty string - should be true: " << str(result) << endl;
    if (!result)
    {
        cout << "  FAIL!!! **********************************" << endl;
        allGood = false;
    }
    }

    // Length 1
    {
    string s = "x";
    auto result = isPal(s);
    cout << "Length 1 - should be true: " << str(result) << endl;
    if (!result)
    {
        cout << "  FAIL!!! **********************************" << endl;
        allGood = false;
    }
    }

    // Length 2 - pal
    {
    string s = "ss";
    auto result = isPal(s);
    cout << "Length 2 - should be true: " << str(result) << endl;
    if (!result)
    {
        cout << "  FAIL!!! **********************************" << endl;
        allGood = false;
    }
    }

    // Length 2 - not pal
    {
    string s = "st";
    auto result = isPal(s);
    cout << "Length 2 - should be false: " << str(result) << endl;
    if (result)
    {
        cout << "  FAIL!!! **********************************" << endl;
        allGood = false;
    }
    }

    // Length 10 - pal
    {
    string s = "abcdeedcba";
    auto result = isPal(s);
    cout << "Length 10 - should be true: " << str(result) << endl;
    if (!result)
    {
        cout << "  FAIL!!! **********************************" << endl;
        allGood = false;
    }
    }

    // Length 10 - not pal
    {
    string s = "abcdefdcba";
    auto result = isPal(s);
    cout << "Length 10 - should be false: " << str(result) << endl;
    if (result)
    {
        cout << "  FAIL!!! **********************************" << endl;
        allGood = false;
    }
    }
}


// test_isPal_general
// Test for isPal: general strings
// Prints results of tests, sets global allGood to false if any fail
void test_isPal_general()
{
    cout << endl;
    cout << "Test suite: general strings"
         << endl;

    {
    string s = "A man, a plan, a canal: Panama!";
    auto result = isPal(s);
    cout << "String #1 - should be true: " << str(result) << endl;
    if (!result)
    {
        cout << "  FAIL!!! **********************************" << endl;
        allGood = false;
    }
    }

    {
    string s = "A man, a clan, a canal: Panama!";
    auto result = isPal(s);
    cout << "String #2 - should be false: " << str(result) << endl;
    if (result)
    {
        cout << "  FAIL!!! **********************************" << endl;
        allGood = false;
    }
    }
}


// main program
// Runs tests for isPal, prints results
int main()
{
    cout << "Test function isPal" << endl;
    test_isPal_letters();

    cout << endl;
    if (allGood)
        cout << "All tests in first suite pass!" << endl;
    else
        cout << "***** SOME TESTS IN FIRST SUITE FAILED *****" << endl;

    test_isPal_general();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

